#ifndef ENEMIES_INCLUDED
#define ENEMIES_INCLUDED

#include "gameobject.h"
#include "map.h"
	
class Enemy : public GameObject {
	// Nothing
	public:
		Enemy(Manager &m) : GameObject(m) { }
};

class Turret : public Enemy {
	private:
		MapBlock::MapItemType type;
		int fireTimer; // ticks until next fire
		int fireSpeed; // ticks between firing
		double desiredAzimuth;
	public:
		static const double TurretHeight = 2.25;
		Turret(Manager &m, MapBlock::MapItemType t);
		virtual void setLocation(const Vect3d &where);
		virtual void render();
		virtual void runLogic();
		virtual ~Turret() { }
		virtual void takeDamage(double amount);
	private:
		void doFire();
};

class Saucer : public Enemy {
	private:
		MapBlock::MapItemType type;
		int fireTimer; // ticks until next fire
		int fireSpeed; // ticks between firing
	public:
		static const double SaucerHeight = 2.0;
		Saucer(Manager &m, MapBlock::MapItemType t);
		virtual void setLocation(const Vect3d &where);
		virtual void render();
		virtual void runLogic();
		virtual ~Saucer() { }
		virtual void takeDamage(double amount);
	private:
		void doFire();
};
		
#endif //ENEMIES_INCLUDED

