#ifndef SHIP_INCLUDED
	#define SHIP_INCLUDED

#include "gameobject.h"
	
class Ship : public GameObject {
	private:
		double roll;
		int fireTimer; // ticks until next fire
		int fireSpeed; // ticks between firing
	public:
		static const double ShipHeight = 2.0;
		Ship(Manager &m) : GameObject(m){ 
			roll = 0;
			azimuth = 90.0;
			location.z = ShipHeight; // initial height
			collidable = true;
			radius = 0.3;
			fireTimer = 0;
			fireSpeed = 15;
		}
		virtual void render();
		virtual void runLogic();
		virtual ~Ship() { }
		virtual void setLocation(const Vect3d &where) { 
			location = where;
			location.z = ShipHeight;
		}
		virtual void takeDamage(double amount);
	private:
		void approachVelocity(const Vect3d & targetVelocity);
		void doFire();
};
		
#endif //SHIP_INCLUDED

