#ifndef SHOT_INCLUDED
#define SHOT_INCLUDED

#include "gameobject.h"
	
class Shot : public GameObject {
	private:
		GameObject * owner;
		int lifeTimer;
		double damage;
	public:
		Shot(Manager &m, GameObject *owner) : GameObject(m) {
			this->owner = owner;
			radius = 0.1;
			projectile = true;
			lifeTimer = 400;
			damage = 30;
		}
		void setVelocity(const Vect3d & v) {
			velocity = v;
		}
		virtual void render();
		virtual void runLogic();
		virtual ~Shot() { }
		virtual void handleCollision(GameObject *other);
};
		
#endif //SHOT_INCLUDED

